-- Functors.
-- Author :: Ulf Norell
-- Created:: 2004-12-14

-- # import Prelude
-- # import Property

FunctorLaws :
  (F : Set -> Set)                          ->
  ((A, B : Set) -> (A -> B) -> F A -> F B) ->
  Type
FunctorLaws F fmap = sig
  id : (A : Set) ->  fmap A A id == id
  compose  : (A, B, C : Set) ->
                (f : B -> C) -> (g : A -> B) ->
                    fmap A C (f <> g)
                    ==
                    (fmap B C f <> fmap A B g)

FunctorOps : (F : Set -> Set) -> Type
FunctorOps F = (A, B : Set) -> (A -> B) -> F A -> F B

Functor : (F : Set -> Set) -> Type
Functor F = sig
  map    : FunctorOps F
  proofs : FunctorLaws F map
  

