
-- # import Relation
-- # import Eq

Ord : (A : Set) -> Type
Ord A = sig
  leq    : DecidableRelation A
  equ    : Eq A
  proofs : TotalOrder (decidableRelation equ.eq)
                      (decidableRelation leq)
  

reflOrd (A : Set) :
        (ordA : Ord A) -> Reflexive (decidableRelation ordA.leq)
reflOrd ordA = \x -> ordA.proofs.refl x x (ordA.equ.proofs.refl x)

invertOrd (A : Set) : Ord A -> Ord A
invertOrd ordA = struct
  leq    = \x y -> ordA.leq y x
  equ    = ordA.equ
  proofs = struct
    refl     = fol-plugin(ordA.equ.proofs.sym, ordA.proofs.refl)
    antisym  = \x y p q -> ordA.proofs.antisym x y q p
    trans    = \x y z p q -> ordA.proofs.trans z y x q p
    total    = fol-plugin(ordA.proofs.total)

lessEq (A : Set) : Ord A -> A -> A -> Bool
lessEq ordA x y = ordA.leq x y

greaterEq (A : Set) : Ord A -> A -> A -> Bool
greaterEq ordA x y = lessEq ordA y x

less (A : Set) : Ord A -> A -> A -> Bool
less ordA x y = ordA.leq x y && not (ordA.leq y x)

greater (A : Set) : Ord A -> A -> A -> Bool
greater ordA x y = less ordA y x

max (A : Set) : Ord A -> A -> A -> A
max ordA x y = if (ordA.leq x y) y x

min (A : Set) : Ord A -> A -> A -> A
min ordA x y = if (ordA.leq y x) y x
